// Code generated by client-gen. DO NOT EDIT.

package fake

import (
	"context"

	configurationv1 "github.com/nginxinc/kubernetes-ingress/pkg/apis/configuration/v1"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	labels "k8s.io/apimachinery/pkg/labels"
	schema "k8s.io/apimachinery/pkg/runtime/schema"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	testing "k8s.io/client-go/testing"
)

// FakeVirtualServerRoutes implements VirtualServerRouteInterface
type FakeVirtualServerRoutes struct {
	Fake *FakeK8sV1
	ns   string
}

var virtualserverroutesResource = schema.GroupVersionResource{Group: "k8s.nginx.org", Version: "v1", Resource: "virtualserverroutes"}

var virtualserverroutesKind = schema.GroupVersionKind{Group: "k8s.nginx.org", Version: "v1", Kind: "VirtualServerRoute"}

// Get takes name of the virtualServerRoute, and returns the corresponding virtualServerRoute object, and an error if there is any.
func (c *FakeVirtualServerRoutes) Get(ctx context.Context, name string, options v1.GetOptions) (result *configurationv1.VirtualServerRoute, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewGetAction(virtualserverroutesResource, c.ns, name), &configurationv1.VirtualServerRoute{})

	if obj == nil {
		return nil, err
	}
	return obj.(*configurationv1.VirtualServerRoute), err
}

// List takes label and field selectors, and returns the list of VirtualServerRoutes that match those selectors.
func (c *FakeVirtualServerRoutes) List(ctx context.Context, opts v1.ListOptions) (result *configurationv1.VirtualServerRouteList, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewListAction(virtualserverroutesResource, virtualserverroutesKind, c.ns, opts), &configurationv1.VirtualServerRouteList{})

	if obj == nil {
		return nil, err
	}

	label, _, _ := testing.ExtractFromListOptions(opts)
	if label == nil {
		label = labels.Everything()
	}
	list := &configurationv1.VirtualServerRouteList{ListMeta: obj.(*configurationv1.VirtualServerRouteList).ListMeta}
	for _, item := range obj.(*configurationv1.VirtualServerRouteList).Items {
		if label.Matches(labels.Set(item.Labels)) {
			list.Items = append(list.Items, item)
		}
	}
	return list, err
}

// Watch returns a watch.Interface that watches the requested virtualServerRoutes.
func (c *FakeVirtualServerRoutes) Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error) {
	return c.Fake.
		InvokesWatch(testing.NewWatchAction(virtualserverroutesResource, c.ns, opts))

}

// Create takes the representation of a virtualServerRoute and creates it.  Returns the server's representation of the virtualServerRoute, and an error, if there is any.
func (c *FakeVirtualServerRoutes) Create(ctx context.Context, virtualServerRoute *configurationv1.VirtualServerRoute, opts v1.CreateOptions) (result *configurationv1.VirtualServerRoute, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewCreateAction(virtualserverroutesResource, c.ns, virtualServerRoute), &configurationv1.VirtualServerRoute{})

	if obj == nil {
		return nil, err
	}
	return obj.(*configurationv1.VirtualServerRoute), err
}

// Update takes the representation of a virtualServerRoute and updates it. Returns the server's representation of the virtualServerRoute, and an error, if there is any.
func (c *FakeVirtualServerRoutes) Update(ctx context.Context, virtualServerRoute *configurationv1.VirtualServerRoute, opts v1.UpdateOptions) (result *configurationv1.VirtualServerRoute, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateAction(virtualserverroutesResource, c.ns, virtualServerRoute), &configurationv1.VirtualServerRoute{})

	if obj == nil {
		return nil, err
	}
	return obj.(*configurationv1.VirtualServerRoute), err
}

// UpdateStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().
func (c *FakeVirtualServerRoutes) UpdateStatus(ctx context.Context, virtualServerRoute *configurationv1.VirtualServerRoute, opts v1.UpdateOptions) (*configurationv1.VirtualServerRoute, error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateSubresourceAction(virtualserverroutesResource, "status", c.ns, virtualServerRoute), &configurationv1.VirtualServerRoute{})

	if obj == nil {
		return nil, err
	}
	return obj.(*configurationv1.VirtualServerRoute), err
}

// Delete takes name of the virtualServerRoute and deletes it. Returns an error if one occurs.
func (c *FakeVirtualServerRoutes) Delete(ctx context.Context, name string, opts v1.DeleteOptions) error {
	_, err := c.Fake.
		Invokes(testing.NewDeleteActionWithOptions(virtualserverroutesResource, c.ns, name, opts), &configurationv1.VirtualServerRoute{})

	return err
}

// DeleteCollection deletes a collection of objects.
func (c *FakeVirtualServerRoutes) DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error {
	action := testing.NewDeleteCollectionAction(virtualserverroutesResource, c.ns, listOpts)

	_, err := c.Fake.Invokes(action, &configurationv1.VirtualServerRouteList{})
	return err
}

// Patch applies the patch and returns the patched virtualServerRoute.
func (c *FakeVirtualServerRoutes) Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *configurationv1.VirtualServerRoute, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewPatchSubresourceAction(virtualserverroutesResource, c.ns, name, pt, data, subresources...), &configurationv1.VirtualServerRoute{})

	if obj == nil {
		return nil, err
	}
	return obj.(*configurationv1.VirtualServerRoute), err
}
