// Code generated by client-gen. DO NOT EDIT.

package v1

import (
	"context"
	"time"

	v1 "github.com/nginxinc/kubernetes-ingress/pkg/apis/configuration/v1"
	scheme "github.com/nginxinc/kubernetes-ingress/pkg/client/clientset/versioned/scheme"
	metav1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	rest "k8s.io/client-go/rest"
)

// VirtualServersGetter has a method to return a VirtualServerInterface.
// A group's client should implement this interface.
type VirtualServersGetter interface {
	VirtualServers(namespace string) VirtualServerInterface
}

// VirtualServerInterface has methods to work with VirtualServer resources.
type VirtualServerInterface interface {
	Create(ctx context.Context, virtualServer *v1.VirtualServer, opts metav1.CreateOptions) (*v1.VirtualServer, error)
	Update(ctx context.Context, virtualServer *v1.VirtualServer, opts metav1.UpdateOptions) (*v1.VirtualServer, error)
	UpdateStatus(ctx context.Context, virtualServer *v1.VirtualServer, opts metav1.UpdateOptions) (*v1.VirtualServer, error)
	Delete(ctx context.Context, name string, opts metav1.DeleteOptions) error
	DeleteCollection(ctx context.Context, opts metav1.DeleteOptions, listOpts metav1.ListOptions) error
	Get(ctx context.Context, name string, opts metav1.GetOptions) (*v1.VirtualServer, error)
	List(ctx context.Context, opts metav1.ListOptions) (*v1.VirtualServerList, error)
	Watch(ctx context.Context, opts metav1.ListOptions) (watch.Interface, error)
	Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts metav1.PatchOptions, subresources ...string) (result *v1.VirtualServer, err error)
	VirtualServerExpansion
}

// virtualServers implements VirtualServerInterface
type virtualServers struct {
	client rest.Interface
	ns     string
}

// newVirtualServers returns a VirtualServers
func newVirtualServers(c *K8sV1Client, namespace string) *virtualServers {
	return &virtualServers{
		client: c.RESTClient(),
		ns:     namespace,
	}
}

// Get takes name of the virtualServer, and returns the corresponding virtualServer object, and an error if there is any.
func (c *virtualServers) Get(ctx context.Context, name string, options metav1.GetOptions) (result *v1.VirtualServer, err error) {
	result = &v1.VirtualServer{}
	err = c.client.Get().
		Namespace(c.ns).
		Resource("virtualservers").
		Name(name).
		VersionedParams(&options, scheme.ParameterCodec).
		Do(ctx).
		Into(result)
	return
}

// List takes label and field selectors, and returns the list of VirtualServers that match those selectors.
func (c *virtualServers) List(ctx context.Context, opts metav1.ListOptions) (result *v1.VirtualServerList, err error) {
	var timeout time.Duration
	if opts.TimeoutSeconds != nil {
		timeout = time.Duration(*opts.TimeoutSeconds) * time.Second
	}
	result = &v1.VirtualServerList{}
	err = c.client.Get().
		Namespace(c.ns).
		Resource("virtualservers").
		VersionedParams(&opts, scheme.ParameterCodec).
		Timeout(timeout).
		Do(ctx).
		Into(result)
	return
}

// Watch returns a watch.Interface that watches the requested virtualServers.
func (c *virtualServers) Watch(ctx context.Context, opts metav1.ListOptions) (watch.Interface, error) {
	var timeout time.Duration
	if opts.TimeoutSeconds != nil {
		timeout = time.Duration(*opts.TimeoutSeconds) * time.Second
	}
	opts.Watch = true
	return c.client.Get().
		Namespace(c.ns).
		Resource("virtualservers").
		VersionedParams(&opts, scheme.ParameterCodec).
		Timeout(timeout).
		Watch(ctx)
}

// Create takes the representation of a virtualServer and creates it.  Returns the server's representation of the virtualServer, and an error, if there is any.
func (c *virtualServers) Create(ctx context.Context, virtualServer *v1.VirtualServer, opts metav1.CreateOptions) (result *v1.VirtualServer, err error) {
	result = &v1.VirtualServer{}
	err = c.client.Post().
		Namespace(c.ns).
		Resource("virtualservers").
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(virtualServer).
		Do(ctx).
		Into(result)
	return
}

// Update takes the representation of a virtualServer and updates it. Returns the server's representation of the virtualServer, and an error, if there is any.
func (c *virtualServers) Update(ctx context.Context, virtualServer *v1.VirtualServer, opts metav1.UpdateOptions) (result *v1.VirtualServer, err error) {
	result = &v1.VirtualServer{}
	err = c.client.Put().
		Namespace(c.ns).
		Resource("virtualservers").
		Name(virtualServer.Name).
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(virtualServer).
		Do(ctx).
		Into(result)
	return
}

// UpdateStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().
func (c *virtualServers) UpdateStatus(ctx context.Context, virtualServer *v1.VirtualServer, opts metav1.UpdateOptions) (result *v1.VirtualServer, err error) {
	result = &v1.VirtualServer{}
	err = c.client.Put().
		Namespace(c.ns).
		Resource("virtualservers").
		Name(virtualServer.Name).
		SubResource("status").
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(virtualServer).
		Do(ctx).
		Into(result)
	return
}

// Delete takes name of the virtualServer and deletes it. Returns an error if one occurs.
func (c *virtualServers) Delete(ctx context.Context, name string, opts metav1.DeleteOptions) error {
	return c.client.Delete().
		Namespace(c.ns).
		Resource("virtualservers").
		Name(name).
		Body(&opts).
		Do(ctx).
		Error()
}

// DeleteCollection deletes a collection of objects.
func (c *virtualServers) DeleteCollection(ctx context.Context, opts metav1.DeleteOptions, listOpts metav1.ListOptions) error {
	var timeout time.Duration
	if listOpts.TimeoutSeconds != nil {
		timeout = time.Duration(*listOpts.TimeoutSeconds) * time.Second
	}
	return c.client.Delete().
		Namespace(c.ns).
		Resource("virtualservers").
		VersionedParams(&listOpts, scheme.ParameterCodec).
		Timeout(timeout).
		Body(&opts).
		Do(ctx).
		Error()
}

// Patch applies the patch and returns the patched virtualServer.
func (c *virtualServers) Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts metav1.PatchOptions, subresources ...string) (result *v1.VirtualServer, err error) {
	result = &v1.VirtualServer{}
	err = c.client.Patch(pt).
		Namespace(c.ns).
		Resource("virtualservers").
		Name(name).
		SubResource(subresources...).
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(data).
		Do(ctx).
		Into(result)
	return
}
